summaryrefslogtreecommitdiff
path: root/scripts
diff options
context:
space:
mode:
authorEugen Wissner <belka@caraus.de>2020-12-09 18:28:42 +0100
committerEugen Wissner <belka@caraus.de>2020-12-09 18:28:42 +0100
commit2910a89d6c59b997a3896f05c6ad7fb65c26f813 (patch)
tree3d3edebdf32b0c972e8449b82be2c10742395d6c /scripts
parentbe64bc6dbb9d0f717f7cbdd83d9371de979d4c63 (diff)
downloadslackbuilder-2910a89d6c59b997a3896f05c6ad7fb65c26f813.tar.gz
Add autoupdater
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/gcc-d.SlackBuild251
-rwxr-xr-xscripts/hhvm.sh60
-rwxr-xr-xscripts/ioncube.sh43
-rwxr-xr-xscripts/universal-ctags.sh44
4 files changed, 398 insertions, 0 deletions
diff --git a/scripts/gcc-d.SlackBuild b/scripts/gcc-d.SlackBuild
new file mode 100755
index 0000000..3e77d2c
--- /dev/null
+++ b/scripts/gcc-d.SlackBuild
@@ -0,0 +1,251 @@
+#!/bin/sh
+
+# Slackware build script for gcc-d
+
+# Copyright 2017-2018 Eugene Wissner, Dachau, Germany
+#
+# Based on the GCC build script by Patrick J. Volkerding, Sebeka, MN, USA
+#
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=gcc-d
+SRCNAM=gdc
+VERSION=${VERSION:-2.081.2}
+GCC_VERSION=8.2.0
+HOST_GDC=2.076.0_b5
+HOST_GCC=5.5.0
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+ LIB_ARCH=i386
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+ LIB_ARCH=i386
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+ LIB_ARCH=amd64
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+ LIB_ARCH=armv7hl
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+ LIB_ARCH=$ARCH
+fi
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+if [ "$ARCH" != "x86_64" ]; then
+ GCC_ARCHOPTS="--with-arch=$ARCH"
+else
+ GCC_ARCHOPTS="--disable-multilib"
+fi
+
+set -e
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+
+#
+# Build bootstrap compiler
+#
+cd $TMP
+rm -rf $SRCNAM-$HOST_GDC gcc-$HOST_GCC
+tar xvf $CWD/gcc-$HOST_GCC.tar.?z*
+tar xvf $CWD/$SRCNAM-$HOST_GDC.tar.?z*
+
+# Apply patches.
+cd $TMP/gcc-$HOST_GCC/gcc
+
+cd $TMP/$SRCNAM-$HOST_GDC
+sh setup-gcc.sh ../gcc-$HOST_GCC
+
+cd $TMP/gcc-$HOST_GCC
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+rm -rf $TMP/bootstrap-gcc-d
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+../gcc-$HOST_GCC/configure \
+ --prefix=$TMP/bootstrap-$PRGNAM \
+ --enable-shared \
+ --disable-bootstrap \
+ --enable-languages=c,c++,d \
+ --enable-threads=posix \
+ --enable-checking=release \
+ --with-system-zlib \
+ --with-python-dir=/lib$LIBDIRSUFFIX/python2.7/site-packages \
+ --enable-libstdcxx-dual-abi \
+ --disable-libunwind-exceptions \
+ --enable-__cxa_atexit \
+ --enable-libssp \
+ --enable-lto \
+ --disable-install-libiberty \
+ --with-gnu-ld \
+ --verbose \
+ --with-arch-directory=$LIB_ARCH \
+ $GCC_ARCHOPTS \
+ --target=${TARGET} \
+ --build=${TARGET} \
+ --host=${TARGET}
+
+make
+make install
+
+#
+# Build D compiler
+#
+cd $TMP
+rm -rf $SRCNAM-$VERSION gcc-$GCC_VERSION
+tar xvf $CWD/gcc-$GCC_VERSION.tar.?z*
+tar xvf $CWD/$SRCNAM-$VERSION.tar.?z*
+
+# Apply patches.
+cd $TMP/gcc-$GCC_VERSION/gcc
+
+cd $TMP/$SRCNAM-$VERSION
+sh setup-gcc.sh ../gcc-$GCC_VERSION
+
+cd $TMP/gcc-$GCC_VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+CC="$TMP/bootstrap-$PRGNAM/bin/gcc" \
+CXX="$TMP/bootstrap-$PRGNAM/bin/g++" \
+CPP="$TMP/bootstrap-$PRGNAM/bin/cpp" \
+GDC="$TMP/bootstrap-$PRGNAM/bin/gdc" \
+LD="$TMP/bootstrap-$PRGNAM/bin/gcc" \
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+../gcc-$GCC_VERSION/configure \
+ --prefix=/usr \
+ --libdir=/usr/lib$LIBDIRSUFFIX \
+ --mandir=/usr/man \
+ --infodir=/usr/info \
+ --enable-shared \
+ --disable-bootstrap \
+ --enable-languages=c,c++,d \
+ --enable-threads=posix \
+ --enable-checking=release \
+ --with-system-zlib \
+ --with-python-dir=/lib$LIBDIRSUFFIX/python2.7/site-packages \
+ --enable-libstdcxx-dual-abi \
+ --disable-libunwind-exceptions \
+ --enable-__cxa_atexit \
+ --enable-libssp \
+ --enable-lto \
+ --disable-install-libiberty \
+ --with-gnu-ld \
+ --verbose \
+ --with-arch-directory=$LIB_ARCH \
+ --program-suffix="-`echo $GCC_VERSION | cut -d. -f1`" \
+ --with-pkgversion="GDC $VERSION" \
+ $GCC_ARCHOPTS \
+ --target=${TARGET} \
+ --build=${TARGET} \
+ --host=${TARGET}
+
+make
+make install DESTDIR=$PKG
+
+# Remove not D related stuff, already available in GCC
+find $PKG/usr/info -type f -not -name "*gdc*" -delete
+rm -r $PKG/usr/man/man7
+rm -r $PKG/usr/share
+#rm -r $PKG/usr/include
+
+#find $PKG/usr/libexec/gcc \
+# \( -type f -or -type l \) -not -name "cc1d" \
+# -delete
+
+#find $PKG/usr/lib$LIBDIRSUFFIX/gcc -mindepth 3 \
+# \( -type f -or -type l \) -not -regex ".*/d/.*" \
+# -delete
+
+#find $PKG/usr/lib$LIBDIRSUFFIX -maxdepth 1 \
+# \( -type f -or -type l \) \
+# -not \( -name "*phobos*" -or -name "*gdruntime*" \) \
+# -delete
+
+(
+ cd $PKG/usr/lib$LIBDIRSUFFIX
+ rm -r python2.7 *.py *.o \
+ libasan.{a,la,so} \
+ libatomic.{a,la,so,so.1} \
+ libcc1.* libgcc_s.* libgomp.* libitm.* liblsan.* \
+ libquadmath.* libsanitizer.spec libssp* \
+ libstdc++fs.* libstdc++.{a,la,so,so.6} \
+ libsupc++.* libtsan.* \
+ libubsan.{a,la,so}
+)
+
+find $PKG/usr -type d -empty -delete
+
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+gzip -9 $PKG/usr/info/*.info
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp $TMP/$SRCNAM-$VERSION/README.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/scripts/hhvm.sh b/scripts/hhvm.sh
new file mode 100755
index 0000000..5aba70b
--- /dev/null
+++ b/scripts/hhvm.sh
@@ -0,0 +1,60 @@
+#!/bin/bash
+
+# This Source Code Form is subject to the terms of the Mozilla Public
+# License, v. 2.0. If a copy of the MPL was not distributed with this
+# file, You can obtain one at https://mozilla.org/MPL/2.0/.
+
+VERSION=${VERSION:-4.32.0}
+
+set -e
+
+git clone https://github.com/facebook/hhvm.git
+mv hhvm hhvm-$VERSION
+
+cd hhvm-$VERSION
+git checkout HHVM-$VERSION
+git submodule update --init --recursive
+
+cd third-party
+rm -rf libsqlite3 \
+ lz4 \
+ pcre
+# libzip
+cd ..
+find -name "\.git*" -print0 | xargs -0 rm -rf
+
+cd ..
+tar Jcvf hhvm-$VERSION.tar.xz hhvm-$VERSION
+rm -rf hhvm-$VERSION
+scp hhvm-$VERSION.tar.xz caraus.de:/srv/httpd/dlackware/download/hosted-sources/hhvm
+CHECKSUM=`md5sum hhvm-$VERSION.tar.xz | cut -d ' ' -f 1`
+
+cat <<EOF > hhvm.info
+PRGNAM="hhvm"
+VERSION="$VERSION"
+HOMEPAGE="https://hhvm.com/"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://download.dlackware.com/hosted-sources/hhvm/hhvm-${VERSION}.tar.xz"
+MD5SUM_x86_64="$CHECKSUM"
+REQUIRES="tbb glog dwarf oniguruma libmemcached krb5 lz4 libsodium"
+MAINTAINER="Eugene Wissner"
+EMAIL="belka@caraus.de"
+EOF
+
+rm -f slackbuilds/development/hhvm/*.tar.xz
+mv \
+ hhvm.info \
+ hhvm-$VERSION.tar.xz \
+ slackbuilds/development/hhvm/
+cd slackbuilds/development/hhvm
+
+# Update version in the SlackBuild.
+sed -i "s#^\(VERSION=\)\${VERSION:-.\+#\1\${VERSION:-$VERSION}#" hhvm.SlackBuild
+
+BRANCH="hhvm${VERSION//.}"
+git checkout master
+git checkout -b $BRANCH
+git add .
+git commit -m "development/hhvm: Updated for version $VERSION"
+#git push origin $BRANCH
diff --git a/scripts/ioncube.sh b/scripts/ioncube.sh
new file mode 100755
index 0000000..c618ea6
--- /dev/null
+++ b/scripts/ioncube.sh
@@ -0,0 +1,43 @@
+#!/bin/bash
+
+# This Source Code Form is subject to the terms of the Mozilla Public
+# License, v. 2.0. If a copy of the MPL was not distributed with this
+# file, You can obtain one at https://mozilla.org/MPL/2.0/.
+
+VERSION=${VERSION:-10.3.9}
+
+set -e
+
+
+wget http://downloads3.ioncube.com/loader_downloads/ioncube_loaders_lin_x86_${VERSION}.tar.gz \
+ http://downloads3.ioncube.com/loader_downloads/ioncube_loaders_lin_x86-64_${VERSION}.tar.gz
+
+CHECKSUM32="`md5sum ioncube_loaders_lin_x86_${VERSION}.tar.gz | cut -d ' ' -f 1`"
+CHECKSUM64="`md5sum ioncube_loaders_lin_x86-64_${VERSION}.tar.gz | cut -d ' ' -f 1`"
+
+mv ioncube_loaders_lin_x86_${VERSION}.tar.gz \
+ ioncube_loaders_lin_x86-64_${VERSION}.tar.gz \
+ slackbuilds/development/ioncube-loader/
+
+cat <<EOF > slackbuilds/development/ioncube-loader/ioncube-loader.info
+PRGNAM="ioncube-loader"
+VERSION="$VERSION"
+HOMEPAGE="https://www.ioncube.com"
+DOWNLOAD="http://downloads3.ioncube.com/loader_downloads/ioncube_loaders_lin_x86_${VERSION}.tar.gz"
+MD5SUM="$CHECKSUM32"
+DOWNLOAD_x86_64="http://downloads3.ioncube.com/loader_downloads/ioncube_loaders_lin_x86-64_${VERSION}.tar.gz"
+MD5SUM_x86_64="$CHECKSUM64"
+REQUIRES=""
+MAINTAINER="Eugene Wissner"
+EMAIL="belka@caraus.de"
+EOF
+
+sed -i "s#^\(VERSION=\)\${VERSION:-.\+#\1\${VERSION:-$VERSION}#" slackbuilds/development/ioncube-loader/ioncube-loader.SlackBuild
+
+BRANCH="ioncube${VERSION//.}"
+cd slackbuilds
+git checkout master
+git checkout -b $BRANCH
+git add development/ioncube-loader
+git commit -m "development/ioncube-loader: Updated for version ${VERSION}"
+git push origin $BRANCH
diff --git a/scripts/universal-ctags.sh b/scripts/universal-ctags.sh
new file mode 100755
index 0000000..06ebe85
--- /dev/null
+++ b/scripts/universal-ctags.sh
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+# This Source Code Form is subject to the terms of the Mozilla Public
+# License, v. 2.0. If a copy of the MPL was not distributed with this
+# file, You can obtain one at https://mozilla.org/MPL/2.0/.
+
+set -e
+
+tar Jcvf ctags-$COMMIT.tar.xz ctags-$COMMIT
+
+rm -rf ctags-$COMMIT
+CHECKSUM=`md5sum ctags-$COMMIT.tar.xz | cut -d ' ' -f 1`
+
+scp ctags-$COMMIT.tar.xz caraus.de:/srv/httpd/dlackware/download/hosted-sources/universal-ctags
+
+cat <<EOF > universal-ctags.info
+PRGNAM="universal-ctags"
+VERSION="$HASH"
+HOMEPAGE="https://ctags.io/"
+DOWNLOAD="https://download.dlackware.com/hosted-sources/universal-ctags/ctags-$COMMIT.tar.xz"
+MD5SUM="$CHECKSUM"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="%README%"
+MAINTAINER="Eugene Wissner"
+EMAIL="belka@caraus.de"
+EOF
+
+rm -f slackbuilds/development/universal-ctags/*.tar.xz
+mv \
+ universal-ctags.info \
+ ctags-$COMMIT.tar.xz \
+ slackbuilds/development/universal-ctags/
+cd slackbuilds/development/universal-ctags
+
+# Update version in the SlackBuild.
+sed -i "s#^\(VERSION=\)\${VERSION:-.\+#\1\${VERSION:-$HASH}#" universal-ctags.SlackBuild
+sed -i "s#^\(GITVERSION=\)\${GITVERSION:-.\+#\1\${GITVERSION:-$COMMIT}#" universal-ctags.SlackBuild
+
+# Commit.
+git checkout master
+#git checkout -b ctags$HASH
+git add .
+git commit -m "development/universal-ctags: Updated for version $HASH"